int val_protocole_recu;
int broche_recu;
int val_broche_recu;
int envoie_broche;
int envoie_val_broche;
int LED1;
int Servomoteur1;
int BP_Actif;
int Ancien_etat_BP;
int etat_bp;
int envoie_protocole;
#include <SoftwareSerial.h>
SoftwareSerial mySerial(6,7);

void broche_A0() {
  envoie_val_broche = round((1/(log((float)(1023-analogRead(A0))*10000/analogRead(A0))/10000)/3975+1/298.15)-273.15);
  mySerial.write(envoie_val_broche);
  // Vide le buffer de la liaison Bluetooth
  mySerial.flush();
}

void LED1_ON() {
  digitalWrite(LED1,HIGH);
  envoie_protocole = 100 + LED1;
  mySerial.write(envoie_protocole);
  // Vide le buffer de la liaison Bluetooth
  mySerial.flush();
}

void broche_A1() {
  envoie_val_broche = round((1/(log((float)(1023-analogRead(A1))*10000/analogRead(A1))/10000)/3975+1/298.15)-273.15);
  mySerial.write(envoie_val_broche);
  // Vide le buffer de la liaison Bluetooth
  mySerial.flush();
}

void LED1_OFF() {
  digitalWrite(LED1,LOW);
  envoie_protocole = LED1;
  mySerial.write(envoie_protocole);
}

void broche_A2() {
  envoie_val_broche = analogRead(A2);
  mySerial.write(envoie_val_broche);
  // Vide le buffer de la liaison Bluetooth
  mySerial.flush();
}

#include <Servo.h>

Servo servo_Servomoteur1;

void Moteur_ON() {
  servo_Servomoteur1.write(90);
  envoie_protocole = 100 + Servomoteur1;
  mySerial.write(envoie_protocole);
}

void broche_A3() {
  envoie_val_broche = analogRead(A3);
  mySerial.write(envoie_val_broche);
  // Vide le buffer de la liaison Bluetooth
  mySerial.flush();
}

void Moteur_OFF() {
  servo_Servomoteur1.write(0);
  envoie_protocole = Servomoteur1;
  mySerial.write(envoie_protocole);
}

// Permet de faire un bistable.
// A chaque appuie du bouton poussoir, on change l'état de la variable Allumer_LED.
void detecte_front_montant() {
  etat_bp = digitalRead(8);
  delay(50);
  if (etat_bp != Ancien_etat_BP) {
    if (!etat_bp) {
      BP_Actif = !BP_Actif;

    }

  }
  Ancien_etat_BP = etat_bp;
}


void setup() {
  mySerial.begin(9600);
    val_protocole_recu = 1;
  broche_recu = 1;
  val_broche_recu = 1;
  envoie_broche = 1;
  envoie_val_broche = 1;
  // La LED est connectée sur la broche 4
  LED1 = 4;
  Servomoteur1 = 2;
  BP_Actif = true;
  Ancien_etat_BP = false;
  etat_bp = false;

  pinMode(A0, INPUT);
  pinMode(LED1, OUTPUT);
  pinMode(A1, INPUT);
  pinMode(A2, INPUT);
  servo_Servomoteur1.attach(Servomoteur1);

  pinMode(8, INPUT);
}

void loop() {
  if (mySerial.available()) {
    val_protocole_recu = mySerial.read();
    if (val_protocole_recu == 102) {
      Moteur_ON();

    }
    if (val_protocole_recu == 2) {
      Moteur_OFF();

    }
    if (val_protocole_recu == 103) {
      envoie_protocole = val_protocole_recu;
      mySerial.write(envoie_protocole);

    }
    if (val_protocole_recu == 3) {
      envoie_protocole = val_protocole_recu;
      mySerial.write(envoie_protocole);

    }
    if (val_protocole_recu == 104) {
      LED1_ON();

    }
    if (val_protocole_recu == 4) {
      LED1_OFF();

    }
    if (val_protocole_recu == 105) {
      envoie_protocole = val_protocole_recu;
      mySerial.write(envoie_protocole);

    }
    if (val_protocole_recu == 5) {
      envoie_protocole = val_protocole_recu;
      mySerial.write(envoie_protocole);

    }
    if (val_protocole_recu == 106) {
      envoie_protocole = val_protocole_recu;
      mySerial.write(envoie_protocole);

    }
    if (val_protocole_recu == 6) {
      envoie_protocole = val_protocole_recu;
      mySerial.write(envoie_protocole);

    }
    if (val_protocole_recu == 107) {
      envoie_protocole = val_protocole_recu;
      mySerial.write(envoie_protocole);

    }
    if (val_protocole_recu == 7) {
      envoie_protocole = val_protocole_recu;
      mySerial.write(envoie_protocole);

    }
    if (val_protocole_recu == 8) {
      envoie_protocole = val_protocole_recu;
      mySerial.write(envoie_protocole);

    }
    if (val_protocole_recu == 108) {
      envoie_protocole = val_protocole_recu;
      mySerial.write(envoie_protocole);

    }
    if (val_protocole_recu == 160) {
      broche_A0();

    }
    if (val_protocole_recu == 161) {
      broche_A1();

    }
    if (val_protocole_recu == 162) {
      broche_A2();

    }
    if (val_protocole_recu == 163) {
      broche_A3();

    }

  }
  detecte_front_montant();
  if (etat_bp) {
    if (BP_Actif) {
      envoie_protocole = 108;

    } else {
      envoie_protocole = 8;

    }
    mySerial.write(envoie_protocole);
    // Vide le buffer de la liaison Bluetooth
    mySerial.flush();

  }

}